plugins["Dicts_info"] = {
  version: "1.0",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Dicts.info Thesaurus",
  directory: currentDirectory,
  aliasstr: "th",
  icon: currentDirectory+"\\favicon.ico",
  description: "Dictionary that makes use of dicts.com",

  pre_string : "{\\rtf1\\ansi\\ansicpg1250\\deff0\\deftab709{\\fonttbl{\\f0\\fnil\\fcharset0 Arial;}}{\\colortbl ;\\red255\\green0\\blue0;}{\\*\\generator Msftedit 5.41.15.1507;}\\viewkind4\\uc1\\pard\\lang2057\\f0\\fs18 ",
  post_string : "\\par\n}",

  doQuery: function doQuery(querynokeyword){
    setStatusBar("Please wait...");
    var history="";
    var url = "http://www.dicts.info/thesaurus.php?word="+querynokeyword;
    var xmlhttp=new ActiveXObject("MSXML2.XMLHTTP");
    xmlhttp.onreadystatechange = function(){
      if (xmlhttp.readyState == 4) {
        var string = xmlhttp.responseText;
        string = string.replace(/\n|\t/g,'');
        var splitString = string.match(/<fieldset.*?>(.*?)<\/fieldset>/g);
        if(!splitString){
          setRichEditMode("Nothing found...");
          return;
        }
        for (var i=0;i<splitString.length; ++i){
          var heading = splitString[i].match(/<legend.*?>.*?<strong>(.*?)<\/strong>/);
          var body = splitString[i].match(/<\/legend>(.*?)<br><br><font size="-1" color="gray">/);
          body = body[1].replace(/^ +/,'');
          body = body.replace(/<b>/g,"\\b ");
          body = body.replace(/<\/b>/g,"\\b0 ");
          body = body.replace(/<u>/g,"\\ul ");
          body = body.replace(/<\/u>/g,"\\ulnone ");
          body = body.replace(/<br> */g,"\\par ");
          body = body.replace(/<.*?>/g,"")
          history = history + "\\ul\\b\\caps "+heading[1]+"\\caps0\\b0\\ulnone\\par\\par " + body + "\\par\\par\\par ";
        }

        setStatusBar("Define");
        var js = plugins["Dicts_info"];
        setRichEditMode(js.pre_string+history+js.post_string);
      }
    }
    xmlhttp.open("GET",url,true);
    xmlhttp.send(null);
  },

  search: function search(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod){
    if(!explicit) return;
    setStatusBar("Define");
    var display = this.pre_string+"Type what you want to search and hit \\b enter\\b0"+this.post_string;
    setRichEditMode(display);
    if(triggermethod){
      this.doQuery(queryraw.replace(new RegExp("^"+this.aliasstr+" "),""));
    }
  }

};
