plugins["Google_Calculator"] = {
  version: "1.0",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Google Calculator",
  directory: currentDirectory,
  icon: currentDirectory + "\\favicon.ico",
  aliasstr: "gcal",
  description: "A simple calculator which uses google calculator functions"
};
(function () {

  var js = plugins["Google_Calculator"];
  var pre_string = "{\\rtf1\\ansi\\ansicpg1250\\deff0\\deftab709{\\fonttbl{\\f0\\fnil\\fcharset0 Arial;}}{\\colortbl ;\\red255\\green0\\blue0;}{\\*\\generator Msftedit 5.41.15.1507;}\\viewkind4\\uc1\\pard\\lang2057\\f0\\fs26 ";
  var post_string = "\\par\n}";

  function doQuery(querynokeyword){
      var url = "http://www.google.com/search?q="+encodeURIComponent(querynokeyword);
      var xmlhttp=new ActiveXObject("MSXML2.XMLHTTP");
      xmlhttp.onreadystatechange = function(){
        if (xmlhttp.readyState == 4) {
          var string = xmlhttp.responseText;
          string = string.match(/<table.*?calc_img\.gif.*?<b>(.*?)<\/b>.*?<\/table>/);
          if(string && string[1]){
            string = string[1].replace(/<.*?>/g,"");
            setStatusBar("Calculate");
            setRichEditMode(pre_string+string+post_string);
          }else{
            setStatusBar("Calculate");
            setRichEditMode(pre_string+"Nothing found..."+post_string);
          }
        }
      }
      xmlhttp.open("GET",url,true);
      xmlhttp.send(null);
  }

  js.search = function onSearchBegin(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod){
    if(!explicit) return;
    setStatusBar("Calculate");
    setRichEditMode(pre_string+"Type what you want to search and hit \\b enter\\b0"+post_string);
    if(triggermethod)
      doQuery( queryraw.replace( new RegExp("^"+js.aliasstr+" "), "") );
  }

}());