({
  // This function uses WebGrab
  usd2czk : function() {
    return this.convert("USD","CZK");
  },
  czk2usd : function() {
    return 1/this.convert("USD","CZK");
  },
  eur2czk : function() {
    return this.convert("EUR","CZK");
  },
  czk2eur : function() {
    return 1/this.convert("EUR","CZK");
  },
  convert : function convert(from,to){
/*Google curency converter from, to
"AED","ANG","ARS","AUD","BGN","BHD","BND","BOB","BRL","BWP","CAD","CHF","CLP",
"CNY","COP","CSD","CZK","DKK","EEK","EGP","EUR","FJD","GBP","HKD","HNL","HRK",
"HUF","IDR","ILS","INR","ISK","JPY","KRW","KWD","KZT","LKR","LTL","MAD","MUR",
"MXN","MYR","NOK","NPR","NZD","OMR","PEN","PHP","PKR","PLN","QAR","RON","RUB",
"SAR","SEK","SGD","SIT","SKK","THB","TRY","TTD","TWD","UAH","USD","VEB","ZAR"*/
    if(!from || !to) return "Wrong parameters";

    if(!this.cache){
      this.cache = {};
    }

    if(this.cache[from+" "+to]){
      return this.cache[from+" "+to];
    }
    
    var out = "error";
    var xmlhttp = new ActiveXObject("MSXML2.XMLHTTP");
    xmlhttp.onreadystatechange = function(){
      if (xmlhttp.readyState == 4) {
        var string = xmlhttp.responseText;

        var m = string.match(/<span class=bld>([0-9\.]+?)&nbsp;\w\w\w<\/span>/);
        if(typeof(m) === "object" && m[1]){
          out = m[1];
        }
      }
    }
    xmlhttp.open("GET", "http://www.google.com/finance/converter?a=1&from="+from+"&to="+to, false);
    xmlhttp.send(null);

    this.cache[from+" "+to] = out;

    return out;
  }
})