({
  hex : function (q) {
    var decnumerals = "0123456789";
    var hexnumerals = "0123456789ABCDEF";
    var maxdec = 4503599627370495;  // Math.pow(16,13)-1
    var decinput = q;

    for (var i = 0; i < decinput.length; i++) {
      if (decnumerals.indexOf(decinput.charAt(i)) == -1) {
        return ("Illegal decimal numeral! Only these symbols are allowed: " + decnumerals);
      }
    }

    // Check if decimal numeral is not too large:
    if (decinput > maxdec) {
      return ("Please enter a decimal numeral not greater than " + maxdec + ".");
    }

    // Convert decimal to hexadecimal numeral:
    var decinput_temp = decinput;
    var factors = 1;
    while (decinput_temp > 15) {
      decinput_temp = Math.floor(decinput_temp / 16);
      factors++;
    }
    var hexoutput = "";
    var mathpow_temp = 0;
    for (var i = factors; i >= 1; i--) {
      mathpow_temp = Math.pow(16, i-1);
      hexoutput = hexoutput + hexnumerals.charAt(Math.floor(decinput / mathpow_temp));
      decinput = decinput - (Math.floor(decinput / mathpow_temp) * mathpow_temp);
    }
    return "0x"+hexoutput;
  },

  hex2dec : function (q) {
    var hexnumerals = "0123456789ABCDEF";
    var maxhex = 13;  // number of places

    // Check if input is a legal hexadecimal numeral:
    var hexinput = q.toUpperCase();
    for (var i = 0; i < hexinput.length; i++) {
      if (hexnumerals.indexOf(hexinput.charAt(i)) == -1) {
        return ("Illegal hexadecimal numeral! Only these symbols are allowed: " + hexnumerals);
      }
    }

    // Check if hexadecimal numeral is not too large:
    if (hexinput.length > maxhex) {
      return ("Please enter a hexadecimal numeral with not more than " + maxhex + " characters!");
    }

    // Convert hexadecimal to decimal:
    var decoutput = 0;
    for (var i = 0; i < hexinput.length; i++) {
      decoutput = decoutput + hexnumerals.indexOf(hexinput.charAt(i)) * Math.pow(16, hexinput.length - i-1);
    }
    return decoutput;
  }
})