({
  oct : function(q) {
// Converts decimal into octal
    var decnumerals = "0123456789";
    var octnumerals = "01234567";
    // Higher values can lead to wrong results (due to JavaScript limitations?):
    var maxdec = 2251799813685247;  // Math.pow(8,17)-1


    // Check if input is a legal decimal numeral:
    var decinput = q;
    for (var i = 0; i < decinput.length; i++) {
      if (decnumerals.indexOf(decinput.charAt(i)) == -1) {
        return ("Illegal decimal numeral! Only these symbols are allowed: " + decnumerals);
      }
    }

    // Check if decimal numeral is not too large:
    if (decinput > maxdec) {
      return ("Please enter a decimal numeral not greater than " + maxdec + ".");
    }

    // Convert decimal to octal numeral:
    var decinput_temp = decinput;
    var factors = 1;
    while (decinput_temp > 7) {
      decinput_temp = Math.floor(decinput_temp / 8);
      factors++;
    }
    var octoutput = "";
    var mathpow_temp = 0;
    for (var i = factors; i >= 1; i--) {
      mathpow_temp = Math.pow(8, i-1);
      octoutput = octoutput + octnumerals.charAt(Math.floor(decinput / mathpow_temp));
      decinput = decinput - (Math.floor(decinput / mathpow_temp) * mathpow_temp);
    }
    return "o"+octoutput;
  },

  oct2dec : function (q) {
// converts octal to decimal
    var octnumerals = "01234567";
    // Higher values can lead to wrong results (due to JavaScript limitations?):
    var maxoct = 17;  // number of places

    // Check if input is a legal octal numeral:
    var octinput = q;
    for (var i = 0; i < octinput.length; i++) {
      if (octnumerals.indexOf(octinput.charAt(i)) == -1) {
        return ("Illegal octal numeral! Only these symbols are allowed: " + octnumerals);
      }
    }

    // Check if octal numeral is not too large:
    if (octinput.length > maxoct) {
      return ("Please enter a octal numeral with not more than " + maxoct + " characters!");
    }

    // Convert octal to decimal:
    var decoutput = 0;
    for (var i = 0; i < octinput.length; i++) {
      decoutput = decoutput + octnumerals.indexOf(octinput.charAt(i)) * Math.pow(8, octinput.length - i-1);
    }
    return decoutput;
  }
})