// plugin script :
displayname="Upload script";
versionstring="1.01.07";
releasedatestring="18.2.2008";
author="Oldrich Svec";
updateurl="";
homepageurl="";
shortdescription="Upload script";
longdescription="Upload script";
advconfigstring="Upload script";
readmestring="Upload script";
iconfilename="icon.ico";

aliasstr="up";
regexstr="^up (\\d{1,2}) {0,1}([^f]{0,8})(f{0,1})$";
scriptregex=/^up (\d{1,2}) {0,1}([^f]{0,8})(f{0,1})$/;
regexfilterstr="";
keywordstr="";
scorestr="300";

// type
UNKNOWN=0; FILE=1; FOLDER=2; ALIAS=3; URL=4; PLUGIN=5; CLIP=5;
// Postprocessing
IMMEDIATE_DISPLAY=0; ADDSCORE=1; MATCH_AGAINST_SEARCH=2;
// search state
STOPPED=0; SEARCHING=1;

var folder, c, my_folder, del, new_ver, version, author_web, ftp, ftpweb, ftpfolder, username, password, currentDirectory, w_dir = new Array();

var pre_string = "{\\rtf1\\ansi\\ansicpg1250\\deff0\\deftab709{\\fonttbl{\\f0\\fnil\\fcharset0 Arial;}}{\\colortbl ;\\red255\\green0\\blue0;}{\\*\\generator Msftedit 5.41.15.1507;}\\viewkind4\\uc1\\pard\\lang2057\\f0\\fs28 ";
var post_string = "\\par\n}";
var welcome_string = "\\ul Welcome to Quick Add for Google Calendar\\ul0\\par";

var xml = new ActiveXObject("MSXML2.DOMDocument");
var xml_setting = new ActiveXObject("MSXML2.DOMDocument");

function uploadsetting(folderspec){
  var fc;
  fc = new Enumerator(folderspec.Files);
  for (; !fc.atEnd(); fc.moveNext()) {
    if(fc.item().Name.search(/^upload_setting\.xml$/) != -1){
      return(fc.item().Name);
    }
  }
  return;
}

function ShowFolderList(folderspec){
  var fso, f, fc, s;
  fso = new ActiveXObject("Scripting.FileSystemObject");
  try{
  f = fso.GetFolder(folderspec);
  }catch(err){
    return;
  }
  fc = new Enumerator(f.SubFolders);
  s = "";
  var k = 0;
  for (; !fc.atEnd(); fc.moveNext()) {
    if(uploadsetting(fc.item())){
      w_dir[k] = fc.item();
      s += k + ")\\tqr\\tx500\\tab " + w_dir[k].Name + "\\par\n";
      k++;
    }
  }
  return(s);
}

function ShowIcon(folderspec){
  var fso, f, fc;
  fso = new ActiveXObject("Scripting.FileSystemObject");
  f = fso.GetFolder(folderspec);
  fc = new Enumerator(f.Files);
  for (; !fc.atEnd(); fc.moveNext()) {
    if(fc.item().Name.search(/^.*\.ico$/) != -1){
      return(fc.item().Name);
    }
  }
  return;
}

function ShowDCUpdate(folderspec){
  var fso, f, fc;
  fso = new ActiveXObject("Scripting.FileSystemObject");
  f = fso.GetFolder(folderspec);
  fc = new Enumerator(f.Files);
  for (; !fc.atEnd(); fc.moveNext()) {
    if(fc.item().Name.search(/^.*\.dcupdate$/) != -1){
      return(fc.item().Name);
    }
  }
  return;
}

function loadOptions() {
 var options=new ActiveXObject("MSXML2.DOMDocument");
    if(!options.load(currentDirectory+"\\options.xml") ||
        options.selectSingleNode("options/folder").getAttribute("value")=='') {
        options.loadXML("<options>\n"+
                        "<folder label='Folder where to search :' value=''/>\n"+
                        "</options>");
        options.save(currentDirectory+"\\options.xml");
        options=null;
        FARR.showOptions();
    }else{
      my_folder=options.selectSingleNode("options/folder").getAttribute("value");
    }
}

function onOptionsChanged() {
    loadOptions();
}

function onInit(c) {
    currentDirectory=c;
    loadOptions();
}

function onSearchBegin(querykey, explicit, queryraw, querynokeyword) {
  if(!explicit) {
    if(aliasstr.indexOf(querynokeyword)!=-1) {
      FARR.setState(querykey,1);
      FARR.emitResult(querykey,aliasstr, aliasstr, iconfilename,ALIAS,IMMEDIATE_DISPLAY,300);
      FARR.setState(querykey,0);
    }
    return;
  }
  FARR.setStrValue("window.richeditmode", pre_string + ShowFolderList(my_folder) + post_string);
  FARR.setStrValue("statusbar","Upload script");
}

function onRegexSearchMatch(querykey,querynokeyword) {
  FARR.setStrValue("window.richeditmode","Please wait...");
  FARR.setStrValue("statusbar","Upload script");
  var match_reg = querynokeyword.match(scriptregex);
  var file = new ActiveXObject("Scripting.FileSystemObject");
  var f = file.GetFolder(my_folder);
  
  if(match_reg[1] && !match_reg[3]){
    folder = w_dir[match_reg[1]];
    if(!folder) {
      FARR.setStrValue("window.richeditmode","Wrong number");
      FARR.setStrValue("statusbar","Upload script");
      return;
    }
    
    if(!xml_setting.load(folder.Path+"\\upload_setting.xml")){
      FARR.setStrValue("window.richeditmode",
        pre_string +
        "Error loading: " +
        "\\upload_setting.xml" +
        post_string);
      FARR.setStrValue("statusbar","Upload script");
      return;
    }
    try{
      author_web = xml_setting.selectSingleNode("options/author_web").getAttribute("value");
      ftp = xml_setting.selectSingleNode("options/ftp").getAttribute("value");
      ftpweb = xml_setting.selectSingleNode("options/ftpweb").getAttribute("value");
      ftpfolder = xml_setting.selectSingleNode("options/ftpfolder").getAttribute("value");
      username = xml_setting.selectSingleNode("options/username").getAttribute("value");
      password = xml_setting.selectSingleNode("options/password").getAttribute("value");
    } catch(err){
      FARR.setStrValue("window.richeditmode","Wrong upload_setting.xml file");
      FARR.setStrValue("statusbar","Upload script");
      return;
    }
    
    version = "";
    if(dc_file_name = ShowDCUpdate(folder)){
      if(!xml.load(folder.Path+"\\"+dc_file_name)){
        FARR.setStrValue("window.richeditmode",
          pre_string +
          "Error loading: " +
          folder.Path + "\\" +
          dc_file_name +
          post_string);
        FARR.setStrValue("statusbar","Upload script");
        return;
      }
      version = xml.selectSingleNode("Local/Version").text;
      new_ver = version.match(/^(.*?)(\d{1,2})$/);
      if(new_ver && new_ver[1] && new_ver[2]) {
        new_ver[2] = parseFloat(new_ver[2])+1;
        new_ver = new_ver[1]+((new_ver[2]<10)?"0":"")+new_ver[2];
        xml.selectSingleNode("Local/Version").text = new_ver;
      }
    } else{
      dc_file_name = folder.Name+".dcupdate";
      version = "undefined";
      new_ver = "1.01.01";
      xml.loadXML("<?xml version=\"1.0\" ?><Local><Label>"+folder.Name+" (FARR2 Plugin)</Label><IconFile>"+ShowIcon(folder)+"</IconFile><WebPage>"+author_web+"</WebPage><InstallDirectory>Plugins\\"+folder.Name+"</InstallDirectory><UpdateFile>"+ftpweb+"/"+ftpfolder+"/"+folder.Name+"/"+folder.Name+".zip</UpdateFile><Version>"+new_ver+"</Version><VersionFileRemote>"+ftpweb+"/"+ftpfolder+"/"+folder.Name+"/versioninfo.xml</VersionFileRemote><InfoFileRemote></InfoFileRemote><UpdateMethod>unzip</UpdateMethod><SignalForUpdate>FindAndRunRobot.exe</SignalForUpdate><CloseForUpdate></CloseForUpdate><BaseDirectory>Find and Run Robot</BaseDirectory></Local>");
    }
    if(match_reg[2]){
      new_ver = match_reg[2];
      xml.selectSingleNode("Local/Version").text = new_ver;
    }
    FARR.setStrValue("window.richeditmode",
      pre_string +
      "Folder name: " + folder.Name + "\\par " +
      "Old Version: " + version + "\\par " +
      "New Version: " + new_ver + "\\par " +
      "To change version type new version.\\par To finish type \"f\"" +
      post_string);
    FARR.setStrValue("statusbar","Upload script");
  }

  if(match_reg[3]){
    var date = new Date();
    if(!file.FolderExists(f.Path+"\\Upload_TEMP"))
      var up_folder = file.CreateFolder(f.Path+"\\Upload_TEMP");
    else
      var up_folder = file.GetFolder(f.Path+"\\Upload_TEMP");
    var v_info_file = up_folder.CreateTextFile("versioninfo.xml",true);
    var month = date.getMonth()+1;
    var versioninfo = "<?xml version=\"1.0\"?>\n<root>\n<Program_Version>"+new_ver+"</Program_Version>\n<Program_Release_Month>"+month+"</Program_Release_Month>\n<Program_Release_Day>"+date.getDate()+"</Program_Release_Day>\n<Program_Release_Year>"+date.getFullYear()+"</Program_Release_Year>\n</root>";
    v_info_file.Write(versioninfo);
    v_info_file.Close();
    
    dc_file = folder.Path+"\\"+dc_file_name;
    if(file.fileExists(dc_file)) file.DeleteFile(dc_file);
    xml.save(dc_file);
    
    if(file.FileExists(folder.Path+"\\fscript.js")){
      var a = file.OpenTextFile(folder.Path+"\\fscript.js",1,false);
      var textik = a.ReadAll();
      a.Close();
      textik = textik.replace(/versionstring=".*?"/,"versionstring=\""+new_ver+"\"");
      textik = textik.replace(/releasedatestring=".*?"/,"releasedatestring=\""+date.getDate()+"."+month+"."+date.getFullYear()+"\"");
      var a = file.OpenTextFile(folder.Path+"\\fscript.js",2,false);
      a.Write(textik);
      a.Close();
    }
    
    var shell = new ActiveXObject("WScript.Shell");
    var cmd = "cmd /K CD "+currentDirectory+" & 7za.exe a -tzip \""+f.Path+"\\Upload_TEMP\\"+folder.Name+".zip\" \""+folder.Path+"\\*\" -x!options.xml -x!*.cfi -x!upload_setting.xml & exit";
    shell.Run(cmd,1,true);
    cmd = "cmd /K CD "+currentDirectory+" & cmd.cmd "+ftp+" "+username+" "+password+" "+folder.Name+" \""+f.Path+"\\Upload_TEMP\\"+folder.Name+".zip\" \""+f.Path+"\\Upload_TEMP\\versioninfo.xml\" "+ftpfolder+" \""+f.Path+"\\Upload_TEMP\\tmp_ftp_script\" & exit";
    shell.Run(cmd,1,true)

    file.DeleteFolder(f.Path+"\\Upload_TEMP");

    FARR.setStrValue("setsearch","");
  }
}

