plugins["Ninjawords_com"] = {
  version: "1.0",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Ninjawords.com",
  directory: currentDirectory,
  icon: currentDirectory + "\\favicon.ico",
  aliasstr: "nw",
  description: "Dictionary that makes use of ninjawords.com"
};

(function () {

  var js = plugins["Ninjawords_com"];

  var loaded = false;
  js.search = function search(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod){
    if(!explicit) return;
    if(triggermethod){
      var match = queryraw.match(new RegExp("^"+js.aliasstr+" (.+)$"));
      if(match && match[1]){
        loaded = true;
        htmlViewURL("http://ninjawords.com/"+match[1]);
        showPleaseWait("Loading..");
      }
    }else{
      showHTML("Ninjawords.com - type a definition and hit enter");
    }
  };
  js.setStrValue = function onSetStrValue(varname,value){
    if(varname == "EmbeddedWb.DocumentComplete"){
      var pl = pluginInCharge();
      if(pl == "Ninjawords_com" && loaded){
        loaded = false;
        execSafeJS(
          "document.getElementById('header').style.display='none';\n\
           document.getElementById('footer').style.display='none';\n\
           document.getElementById('footer-area').style.display='none';\n\
           document.getElementById('search-area').style.display='none';\n\
           document.body.style.backgroundImage='none';\n\
           document.body.style.marginLeft='5';\n\
           document.getElementById('results').style.fontFamily='times new roman';\n\
           document.getElementById('history').style.display='none';\n\
           document.getElementById('history-iphone').style.display='none';\n\
           document.getElementById('hr-container').style.display='none';\n\
           ");
        hidePleaseWait();
      }
    }
  }
}());