/*global params, pu */ // jslint be quiet
(function () {
  var name;
  // NOTE: no spaces in name
  name = "SanitizeAmazonURL";
  function caption(stxt) {
    return "Sanitize Amazon.com URL";
  }
  function hint(stxt) {
    return ""; // XXX
  }
  function icon(stxt) {
    return pu.pidir + "\\icons\\sanitize.ico";
  }
  function launch(stxt) {
    return "farr://pcommand " + 
           aliasstr + " " +
           "xform " + 
           name + " " + // NOTE: no spaces in name
           stxt;
  }
	function display(stxt) {
		var m;
		m = /^https?:\/\/.*\/ref=.*$/.exec(stxt);
		if (m === null) {
			return false;
		} else {
			return true;
		}
	}
  function code(argtxt) {
		var m;
		// http://www.amazon.com/Mythical-Man-Month-Software-Engineering-Anniversary/dp/0201835959/ref=stuff
		// ->
		// http://www.amazon.com/Mythical-Man-Month-Software-Engineering-Anniversary/dp/0201835959/
		m = /^(.*\/)ref=.*$/.exec(argtxt);
		if (m === null) {
			pu.displayAlertMessage("Failed to sanitize URL");
			return null;
		} else {
			return m[1];
		}
  }
  return {name: name,
          caption: caption,
          hint: hint,
          icon: icon,
          launch: launch,
					display: display,
					code: code};
} ());