({
  bin : function bin (n){
/*DESCRIPTION: Returns a string representation of the binary convertion of "n".
PARAMETERS: n - a positive integer.                                          */
    var out = "";
    var temp;

    if(!this.isInteger(n) || n < 0)  {
     return ("return  \"toBinary\": " + n + " is not valid number.");
    }
    if(n == 0)
     return 0;

    temp = n;
    while(temp > 0)  {
      out =  (temp % 2) + out;
      temp = parseInt(temp / 2);
    }
    return "0b"+out;
  },

  bin2dec : function bin2dec(n){
/*DESCRIPTION: Returns an integer.
PARAMETERS: n - a string representation of the binary number.                */
    var out = 0;
    var temp = "";
    var startFound = false;

    temp += n;

    if(!validBinaryNumber(temp))
      return "Not a valid binary number";

    for(var i = 0; i < temp.length; i++) {
      if(temp.charAt(i) == '1')
  	  startFound = true;

      if(startFound)
        out += parseInt(temp.charAt(i)) * Math.pow(2, temp.length - (i + 1));
    }
    return out;
  }
})