({
  rom2dec : function(roman) {
    var chars = new Array();
    chars['N'] = 1000000; chars['O'] = 500000; chars['P'] = 100000; chars['Q'] = 50000; chars['R'] = 10000; chars['S'] = 5000; chars['M'] = 1000; chars['D'] = 500; chars['C'] = 100; chars['L'] = 50; chars['X'] = 10; chars['V'] = 5; chars['I'] = 1;

    var decimal = 0;
    var minus = 1;
    var state = 0;

    roman.toUpperCase();
    for (var i = roman.length - 1; i >= 0; i--) {
      if (roman.substr(i,1) == '-') {
        minus = - minus;
      } else if (state > chars[roman.substr(i,1)]) {
        decimal -= chars[roman.substr(i,1)];
        minus = 1;
      } else {
        decimal += chars[roman.substr(i,1)];
        state = chars[roman.substr(i,1)];
        minus = 1;
      }
    }
    return minus * decimal;
  },

  dec2rom : function(number) {
    Math.round(number);
    var chars = new Array();
    chars['N'] = 1000000; chars['O'] = 500000; chars['P'] = 100000; chars['Q'] = 50000; chars['R'] = 10000; chars['S'] = 5000; chars['M'] = 1000; chars['D'] = 500; chars['C'] = 100; chars['L'] = 50; chars['X'] = 10; chars['V'] = 5; chars['I'] = 1;

    var last = '';
    var roman = '';
    if (number < 0) {
      roman = '-';
      number = - number;
    }

    for (var letter in chars) {
      var decimal = chars[letter];
      var temp = '';
      while (number >= decimal) {
        number -= decimal;
        temp += letter;
      }
      if (last && temp.length == 4) {
        temp = letter + last;
      } else if (temp == '' && number > (0.8 * decimal)) {
        temp = MathExt.ToRoman( - (number - decimal)) + letter;
        number = 0;
      }
      last = letter;
      roman += temp;
    }
    return roman;
  }
})