// binary replacement (invoke by 0b)
q = q.replace(/(^|\W)0b([01]+?)(?=$|\W)/g,
  function(str,p1,p2,p3,o,s){
    return p1+func.bin2dec(p2);
  });

// hex replacement (invoke by 0x)
q = q.replace(/(^|\W)0x([A-Fa-f0-9]+?)(?=$|\W)/g,
  function(str,p1,p2,p3,o,s){
    return p1+func.hex2dec(p2);
  });

// oct replacement (invoke by o)
q = q.replace(/(^|\W)o([0-7]+?)(?=$|\W)/g,
  function(str,p1,p2,p3,o,s){
    return p1+func.oct2dec(p2);
  });


  
q = replacePows(q);  

function replacePows(p){
  function getNum(s,bool){ // bool true => 0 -> x; bool false x -> 0
    var count = 0;
    if((bool && s.charAt(0) == "(") || (!bool && s.charAt(s.length-1) == ")") ){
      var t = 0;
      for (var x = 0; x < s.length; x++){
        t = bool ? x : s.length - x - 1;
        var cur = s.charAt(t);
        if (cur == "(") bool ? count++ : count--;
        if (cur == ")") bool ? count-- : count++;
        if (count == 0 ) break;
      }
      if(count != 0)
        return false;
      else
        return bool ? s.substr(0,t+1) : s.substr(t,s.length-t);
    } else {
      var r = bool ? s.match(/^[\d\.Ee]+/) : s.match(/[\d\.Ee]+$/);
      if(r && r[0])
        return r[0];
      else
        return false;
    }
  }
  var pos = 0;
  var l = 1;
  while(l){
    pos = p.indexOf("^",pos+1);
    if(pos == -1) break;
    var right = getNum(p.substr(pos+1),true);
    var left = getNum(p.substr(0,pos),false);
    if(left && right)
      p = p.replace(left+"^"+right,"pow("+left+","+right+")");
  }
  return p;
}