/*global FARR, dan */
var displayname = "Akete",
    versionstring = "1.0.0.2",
    releasedatestring = "Dec 16th, 2008",
    author = "ewemoa",
    updateurl = "",
    homepageurl = "",
    shortdescription = "Akete",
    longdescription = "FARR-specific file associations",
    advconfigstring = "",
    readmestring = "FScript",
    iconfilename = "Akete.ico",
    //
    aliasstr = "",
    regexstr = "",
    regexfilterstr = "",
    keywordstr = "",
    scorestr = "";
// SEE THE BOTTOM OF THE FILE FOR MAKING GLOBAL ENTRY POINTS
//
// dan - (d)estructuring (a)ssignment (n)eeded :)
// XXX: why the parens surrounding the function () { ... } below?
//           seems to help notepad++'s Function List plugin
// XXX: dan is not preceded by 'var' because then delete will fail...
dan = (function () {
      // emitResult() / onProcessTrigger() types
  var UNKNOWN = 0, FILE = 1, FOLDER = 2, ALIAS = 3, URL = 4, 
      PLUGIN = 5, CLIP = 6, ALIASFILE = 7,
      // postprocessing for emitResult()
      IMMEDIATE_DISPLAY = 0, ADD_SCORE = 1, MATCH_AGAINST_SEARCH = 2,
      // search state
      STOPPED = 0, SEARCHING = 1,
      // trigger results
      HANDLED = 1, CLOSE = 2;
  function onProcessTrigger(path, title, groupname, pluginid, thispluginid, 
                            score, entrytype, args) {
    var match, apppath, ext, launchstr;
    switch (entrytype) {
      case FILE:
        // XXX: dot inside square brackets escaping?
        match = /\.([^\.]+)$/i.exec(path); 
        // XXX: in general, better to handle an alias string w/ 
        //      $$1-style interpolation, but not doing that yet
        apppath;
        if (match) {
          ext = match[1]; 
          try {
            apppath = FARR.getStrValue("uservar.Akete." + ext);
          } catch (e) {
            return;
          }
          // XXX: check whether path makes sense?
          if (apppath) {
            launchstr = apppath + " " + "\"" + path + "\"";
            FARR.setStrValue("launch", launchstr);
            return HANDLED | CLOSE;
          }
          return;
        }
        return;
        //break;
      default:
        return;
    }
    return;
  }
  return [onProcessTrigger];
} ());
// defined entry points
var onProcessTrigger = dan[0];

// jslint complains, but mdc documentation on delete suggests this should work
delete dan;

// Local Variables:
// c-basic-offset: 2
// End:
